#!/usr/bin/env python

"""
Handle Confluence wiki requests performing searches.
"""

from urllib import urlencode
import cgi, os, sys

# An empty string means that the wiki is anchored at the site root.

URL_PREFIX = ""

def redirect(args):
    location = "%s/?%s" % (URL_PREFIX, urlencode(args))

    print """\
Status: 302 Redirect to page
Location: %s
Content-Type: text/html

<html>
<head><title>Redirecting to Page</title></head>
<body>
<h1>Redirecting to Page</h1>
<p>If you see this message, try following <a href="%s">this link</a>.</p>
</body>
</html>
""" % (location, cgi.escape(location, True))
    sys.exit(0)

def main():
    args = cgi.parse_qs(os.environ.get("QUERY_STRING", ""))
    path = os.environ.get("PATH_INFO", "").strip("/")
    space = (args.get("searchQuery.spaceKey") or args.get("where") or [None])[0]
    query = (args.get("searchQuery.queryString") or args.get("queryString") or [None])[0]

    search = []
    if space:
        search.append("title:%s/" % space)
    if query:
        search.append(query)
    search = " ".join(search)

    redirect({
        "action"        : "fullsearch",             # Moin action performing searches
        "context"       : "180",                    # Textual context in characters
        "value"         : search,
        "fullsearch"    : "Text"                    # Indicates a page text (not title) search
        })

if __name__ == "__main__":
    main()

# vim: tabstop=4 expandtab shiftwidth=4
